# Python Problem Set
1. Write a program that accepts network as input and list all ip addresses in
    that network.
2. Write a script to convert multiple images into animated gif.
3. Write a script that converts text in clipboard into a string.
    <br/>Hint: Use pyperclip
4. Write a program which will find all such numbers which are divisible by 7 
    but are not a multiple of 5,between 2000 and 3200 (both included). 
    The numbers obtained should be printed in a comma-separated sequence on a single line.
5. Write a program which can compute the factorial of a given numbers.
```
The results should be printed in a comma-separated sequence on a single line.
Suppose the following input is supplied to the program:
8
Then, the output should be:
40320
```
6. With a given integral number n, write a program to generate a dictionary that
    contains (i, i*i) such that is an integral number between 1 and n (both 
    included). and then the program should print the dictionary.
```
Suppose the following input is supplied to the program:
8
Then, the output should be:
{1: 1, 2: 4, 3: 9, 4: 16, 5: 25, 6: 36, 7: 49, 8: 64}
```
7. Write a program which accepts a sequence of comma-separated numbers from 
    console and generate a list and a tuple which contains every number.
```
Suppose the following input is supplied to the program:
34,67,55,33,12,98
Then, the output should be:
['34', '67', '55', '33', '12', '98']
('34', '67', '55', '33', '12', '98')
```
8. Define a class which has at least two methods:
<br/>getString: to get a string from console input
<br/>printString: to print the string in upper case.
<br/>Also please include simple test function to test the class methods.
```
Hints:
Use init method to construct some parameters
```
9. Write a program that calculates and prints the value according to the given 
    formula:
<br/>Q = Square root of [(2 C D)/H]
<br/>Following are the fixed values of C and H:
<br/>C is 50. H is 30.
<br/>D is the variable whose values should be input to your program in a 
    comma-separated sequence.
```
Example
Let us assume the following comma separated input sequence is given to the program:
100,150,180
The output of the program should be:
18,22,24
Hints:
If the output received is in decimal form, it should be rounded off to its nearest value (for example, if the output received is 26.0, it should be printed as 26)
In case of input data being supplied to the question, it should be assumed to be a console input.
```
10. Write a program which takes 2 digits, X,Y as input and generates a 
    2-dimensional array. The element value in the i-th row and j-th column of 
    the array should be i*j.
<br/>Note: i=0,1.., X-1; j=0,1,¡¬Y-1.
```
Example
Suppose the following inputs are given to the program:
3,5
Then, the output of the program should be:
[[0, 0, 0, 0, 0], [0, 1, 2, 3, 4], [0, 2, 4, 6, 8]]
Hints:
Note: In case of input data being supplied to the question, it should be assumed to be a console input in a comma-separated form.
```
11. Write a program that accepts a comma separated sequence of words as input 
    and prints the words in a comma-separated sequence after sorting them 
    alphabetically.
```
Suppose the following input is supplied to the program:
without,hello,bag,world
Then, the output should be:
bag,hello,without,world
Hints:
In case of input data being supplied to the question, it should be assumed to be a console input.
```
12. Write a program that accepts sequence of lines as input and prints the lines after making all characters in the sentence capitalized.
```
Suppose the following input is supplied to the program:
Hello world
Practice makes perfect
Then, the output should be:
HELLO WORLD
PRACTICE MAKES PERFECT
```
13. Write a program that accepts a sequence of whitespace separated words as input and prints the words after removing all duplicate words and sorting them alphanumerically.
```
Suppose the following input is supplied to the program:
hello world and practice makes perfect and hello world again
Then, the output should be:
again and hello makes perfect practice world
Hints:
In case of input data being supplied to the question, it should be assumed to be a console input.
We use set container to remove duplicated data automatically and then use sorted() to sort the data.
```
14. Write a program which accepts a sequence of comma separated 4 digit binary numbers as its input and then check whether they are divisible by 5 or not. The numbers that are divisible by 5 are to be printed in a comma separated sequence.
```
Example:
0100,0011,1010,1001
Then the output should be:
1010
Notes: Assume the data is input by console.
```
15. Write a program, which will find all such numbers between 1000 and 3000 (both included) such that each digit of the number is an even number. The numbers obtained should be printed in a comma-separated sequence on a single line.
16. Write a program that accepts a sentence and calculate the number of letters and digits.
```
Suppose the following input is supplied to the program:
hello world! 123
Then, the output should be:
LETTERS 10
	DIGITS 3
```
17. Write a program that accepts a sentence and calculate the number of upper case letters and lower case letters.
```
Suppose the following input is supplied to the program:
Hello world!
Then, the output should be:
UPPER CASE 1
	LOWER CASE 9
```
18. Write a program that computes the value of a+aa+aaa+aaaa with a given digit as the value of a.
```
Suppose the following input is supplied to the program:
9
Then, the output should be:
11106
```
19. Use a list comprehension to square each odd number in a list. The list is input by a sequence of comma-separated numbers.
```
Suppose the following input is supplied to the program:
1,2,3,4,5,6,7,8,9
Then, the output should be:
1,9,25,49,81
```
20. Write a program that computes the net amount of a bank account based a transaction log from console input. The transaction log format is shown as following:
<br/>D 100
<br/>W 200
<br/>D means deposit while W means withdrawal.
```
Suppose the following input is supplied to the program:
D 300
D 300
W 200
D 100
Then, the output should be:
500
```
21. A website requires the users to input username and password to register. Write a program to check the validity of password input by users.
Following are the criteria for checking the password:
    1. At least 1 letter between [a-z]
    2.	At least 1 number between [0-9]
    3.	At least 1 letter between [A-Z]
    4.	At least 1 character from [$#@]
    5.	Minimum length of transaction password: 6
    6.	Maximum length of transaction password: 12
<br/>Your program should accept a sequence of comma separated passwords and will check them according to the above criteria. Passwords that match the criteria are to be printed, each separated by a comma.
```
Example
If the following passwords are given as input to the program:
ABd1234@1,a F1#,2w3E*,2We3345
Then, the output of the program should be:
ABd1234@1
```
22. You are required to write a program to sort the (name, age, height) tuples by ascending order where name is string, age and height are numbers. The tuples are input by console. The sort criteria is:
    1. Sort based on name;
    2. Then sort based on age;
    3. Then sort by score.
    <br/>The priority is that name > age > score.
```
If the following tuples are given as input to the program:
Tom,19,80
John,20,90
Jony,17,91
Jony,17,93
Json,21,85
Then, the output of the program should be:
[('John', '20', '90'), ('Jony', '17', '91'), ('Jony', '17', '93'), ('Json', '21', '85'), ('Tom', '19', '80')]
```
23. Define a class with a generator which can iterate the numbers, which are divisible by 7, between a given range 0 and n.
    <br/>Hints: Consider use yield
24. A robot moves in a plane starting from the original point (0,0). The robot can move toward UP, DOWN, LEFT and RIGHT with a given steps. The trace of robot movement is shown as the following:
    <br/>UP 5
    <br/>DOWN 3
    <br/>LEFT 3
    <br/>RIGHT 2
    <br/>¡¬
    <br/>The numbers after the direction are steps. Please write a program to compute the distance from current position after a sequence of movement and original point. If the distance is a float, then just print the nearest integer.
```
Example:
If the following tuples are given as input to the program:
UP 5
DOWN 3
LEFT 3
RIGHT 2
Then, the output of the program should be:
2
```
25. Write a program to compute the frequency of the words from the input. The output should output after sorting the key alphanumerically.
```
Suppose the following input is supplied to the program:
New to Python or choosing between Python 2 and Python 3? Read Python 2 or Python 3.
Then, the output should be:
2:2
3.:1
3?:1
New:1
Python:5
Read:1
and:1
between:1
choosing:1
or:2
to:1
Hints
In case of input data being supplied to the question, it should be assumed to be a console input.
```
26. Write a method which can calculate square value of number
    <br/>Hints: Using the ** operator
27. Python has many built-in functions, and if you do not know how to use it, you can read document online or find some books. But Python has a built-in document function for every built-in functions.
    <br/>Please write a program to print some Python built-in functions documents, such as abs(), int(), raw_input()
    <br/>And add document for your own function
    <br/>Hints: The built-in document method is doc
28. Define a class, which have a class parameter and have a same instance parameter.
    <br/>Hints: Define a instance parameter, need add it in init method
    <br/>You can init a object with construct parameter or set the value later
29. Define a function which can compute the sum of two numbers.
    <br/>Hints: Define a function with two numbers as arguments.
    <br/>You can compute the sum in the function and return the value.
30. Define a function that can convert a integer into a string and print it in console.
    <br/>Hints: Use str() to convert a number to string.
31. Define a function that can accept two strings as input and concatenate them and then print it in console.
    <br/>Hints: Use + to concatenate the strings
32. Define a function that can accept two strings as input and print the string with maximum length in console. If two strings have the same length, then the function should print al l strings line by line.
    <br/>Hints: Use len() function to get the length of a string
33. Define a function that can accept an integer number as input and print the "It is an even number" if the number is even, otherwise print "It is an odd number".
    <br/>Hints: Use % operator to check if a number is even or odd.
34. Define a function which can print a dictionary where the keys are numbers between 1 and 3 (both included) and the values are square of keys.
    <br/>Hints:
    <br/>Use dict[key]=value pattern to put entry into a dictionary.
    <br/>Use ** operator to get power of a number.
35. Define a function which can print a dictionary where the keys are numbers between 1 and 20 (both included) and the values are square of keys.
    <br/>Hints:
    <br/>Use dict[key]=value pattern to put entry into a dictionary.
    <br/>Use ** operator to get power of a number.
    <br/>Use range() for loops.
36. Define a function which can generate a dictionary where the keys are numbers between 1 and 20 (both included) and the values are square of keys. The function should just print the values only.
    <br/>Hints:
    <br/>Use dict[key]=value pattern to put entry into a dictionary.
    <br/>Use ** operator to get power of a number.
    <br/>Use range() for loops.
    <br/>Use keys() to iterate keys in the dictionary. Also we can use item() to get key/value pairs.
37. Define a function which can generate a dictionary where the keys are numbers between 1 and 20 (both included) and the values are square of keys. The function should just print the keys only.
    <br/>Hints:
    <br/>Use dict[key]=value pattern to put entry into a dictionary.
    <br/>Use ** operator to get power of a number.
    <br/>Use range() for loops.
    <br/>Use keys() to iterate keys in the dictionary. Also we can use item() to get key/value pairs.
38. Define a function which can generate and print a list where the values are square of numbers between 1 and 20 (both included).
    <br/>Hints:
    <br/>Use ** operator to get power of a number.
    <br/>Use range() for loops.
    <br/>Use list.append() to add values into a list.
39. Define a function which can generate a list where the values are square of numbers between 1 and 20 (both included). Then the function needs to print the first 5 elements in the list.
    <br/>Hints:
    <br/>Use ** operator to get power of a number.
    <br/>Use range() for loops.
    <br/>Use list.append() to add values into a list.
    <br/>Use [n1:n2] to slice a list
40. Define a function which can generate a list where the values are square of numbers between 1 and 20 (both included). Then the function needs to print the last 5 elements in the list.
    <br/>Hints:
    <br/>Use ** operator to get power of a number.
    <br/>Use range() for loops.
    <br/>Use list.append() to add values into a list.
    <br/>Use [n1:n2] to slice a list
41. Define a function which can generate a list where the values are square of numbers between 1 and 20 (both included). Then the function needs to print all values except the first 5 elements in the list.
    <br/>Hints:
    <br/>Use ** operator to get power of a number.
    <br/>Use range() for loops.
    <br/>Use list.append() to add values into a list.
    <br/>Use [n1:n2] to slice a list
42. Define a function which can generate and print a tuple where the value are square of numbers between 1 and 20 (both included).
    <br/>Hints:
    <br/>Use ** operator to get power of a number.
    <br/>Use range() for loops.
    <br/>Use list.append() to add values into a list.
    <br/>Use tuple() to get a tuple from a list.
43. With a given tuple (1,2,3,4,5,6,7,8,9,10), write a program to print the first half values in one line and the last half values in one line.
    <br/>Hints: Use [n1:n2] notation to get a slice from a tuple.
44. Write a program to generate and print another tuple whose values are even numbers in the given tuple (1,2,3,4,5,6,7,8,9,10).
    <br/>Hints:
    <br/>Use "for" to iterate the tuple
    <br/>Use tuple() to generate a tuple from a list.
45. Write a program which accepts a string as input to print "Yes" if the string is "yes" or "YES" or "Yes", otherwise print "No".
    <br/>Hints: Use if statement to judge condition.
46. Write a program which can filter even numbers in a list by using filter function. The list is: [1,2,3,4,5,6,7,8,9,10].
    <br/>Hints:
    <br/>Use filter() to filter some elements in a list.
    <br/>Use lambda to define anonymous functions.
47. Write a program which can map() to make a list whose elements are square of elements in [1,2,3,4,5,6,7,8,9,10].
    <br/>Hints:
    <br/>Use map() to generate a list.
    <br/>Use lambda to define anonymous functions.
48. Write a program which can map() and filter() to make a list whose elements are square of even number in [1,2,3,4,5,6,7,8,9,10].
    <br/>Hints:
    <br/>Use map() to generate a list.
    <br/>Use filter() to filter elements of a list.
    <br/>Use lambda to define anonymous functions.
49. Write a program which can filter() to make a list whose elements are even number between 1 and 20 (both included).
    <br/>Hints:
    <br/>Use filter() to filter elements of a list.
    <br/>Use lambda to define anonymous functions.
50. Write a program which can map() to make a list whose elements are square of numbers between 1 and 20 (both included).
    <br/>Hints:
    <br/>Use map() to generate a list.
    <br/>Use lambda to define anonymous functions.
